import java.util.Scanner;

/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {
	
		public static void main(String[] args) {
        	
            // Read from the standard input with java.util.Scanner
            Scanner scanner = new Scanner(System.in);
            int i;
            
            // Read m and then m integers into new array A
            int m = scanner.nextInt();
            int[] A = new int[m];
            for (i = 0; i < m; i++)
                    A[i] = scanner.nextInt();
            
            // Read n and then n integers into new array B
            int n = scanner.nextInt();
            int[] B = new int[n];
            for (i = 0; i < n; i++)
                    B[i] = scanner.nextInt();

            scanner.close();

            int Apos = 0, Bpos = 0, matches = 0;
            
            while (Apos < m && Bpos < n) {
            	if (A[Apos] % 4 != 0) {
            		// The length is not a multiple of 4, continue with next length
            		Apos += 1;
            	} else {
            		int edge = A[Apos] / 4;
            		if (B[Bpos] == edge * edge) {
            			// The current area matches the current length!
            			
            			// Commented before submitting:
            			// System.err.println("Matching len " + A[Apos] + " and area " + B[Bpos]);
            			matches += 1;
            			Apos += 1;
            			Bpos += 1;
            		} else {
            			// Is the ribbon too small, or the box too small?
            			if (B[Bpos] < edge * edge) {
            				// The box is too small, move on to the next one
            				Bpos += 1;
            			} else {
            				// The ribbon is too small, move on to the next one
            				Apos += 1;
            			}
            		}
            	}
            }

            // Output the number of matching pairs
            System.out.println(matches); 

        }
}
